<template>
  <div class="register">
    <h1>Registro</h1>

    <form class="form-group" @submit.prevent="onRegister">
      <div class="field">
        <input
          type="text"
          placeholder="Correo Electronico"
          class="form-control input-sm"
          v-model="formData.email"
          :class="{ error: formError.email }"
        />
      </div>

      <div class="field">
        <input
          type="password"
          placeholder="Contraseña"
          class="form-control input-sm"
          v-model="formData.password"
          :class="{ error: formError.password }"
        />
      </div>

      <div class="field">
        <input
          type="password"
          placeholder="Repetir Contraseña"
          class="form-control input-sm"
          v-model="formData.repeatPassword"
          :class="{ error: formError.repeatPassword }"
        />
      </div>
      <br />

      <button type="submit" class="btn btn-success">Registrar</button>
    </form>

    <p @click="changeForm">Iniciar sesion</p>
  </div>
</template>

<script>
import { ref } from "vue";
import * as Yup from "yup";
import { Auth } from "../../utils/firebase";

export default {
  name: "Register",
  props: {
    changeForm: Function,
  },

  setup() {
    let formData = {};
    let formError = ref({});
    let loading = ref(false);

    const schemaForm = Yup.object().shape({
      email: Yup.string().email(true).required(true),
      password: Yup.string().required(true),
      repeatPassword: Yup.string()
        .required(true)
        .oneOf([Yup.ref("password")], true),
    });

    const onRegister = async () => {
      loading.value = true;
      formError.value = {};

      try {
        await schemaForm.validate(formData, { abortEarly: false });
        try {
          const { email, password } = formData;
          await Auth.createUserWithEmailAndPassword(email, password);
        } catch (error) {
          console.log(error);
        }
      } catch (err) {
        err.inner.forEach((error) => {
          formError.value[error.path] = error.message;
        });
      }
      loading.value = false;
    };

    return {
      formData,
      onRegister,
      formError,
      loading,
    };
  },
};
</script>

<style lang="scss" scoped>
.register {
  background-color: #fff;
  padding: 30px;
  box-shadow: 0px 0px 38px -5px rgba(0, 0, 0, 0.45);
  width: 400px;
  border-radius: 10px;

  h1 {
    text-align: center;
    margin-bottom: 30px;
    color: rgb(112, 109, 109);
  }

  form {
    input.error {
      border-color: #faa;
      background-color: #ffeded;
    }

    input {
      margin-top: 2%;
    }

    button {
      width: 100%;
      background-color: #3ab025;
    }
  }

  p {
    text-align: center;
    margin-top: 30px;

    &:hover {
      cursor: pointer;
      opacity: 0.8;
    }
  }
}
</style>
